Toca Race Driver 3

Informations

Creator Message
thib25 Anonymous

Information

This installer has been approved by the team.

Informations

Platforms:
Downloads: 18267
Wine: 4.0.4

Feedbacks

Description

Rallying, 2006. Wikipedia.

Note: do not install GameSpy. If the game fail to start (AMD GPU), do install the component 'directx9'.

PC Gaming wiki. Appdb.winehq.org

Screenshots

MiniatureMiniature

Source code

#!/bin/bash
# Date : (2020-06-03)
# Last revision : see the changelog below
# Wine version used : see the changelog below
# Distribution used to test : XUbuntu 18.04 64 bits
# Author : Dadu042
# Licence : Retail
# Only For : http://www.playonlinux.com
#
# TESTED Editions: DVD v1.1 ? (hits collection 2008)
#
# Middlewares used by this software : .
#
#
#
# CHANGELOG:
# thib25 (2010-01-23)
#   First script. Distribution used to test : Ubuntu 9.10.
# Dadu042 (2019-08-01)
#   Wine 1.1.35 -> 2.22 Because on Xubuntu (18.04 x64), once the retail DVD installed Wine crashed before to show anything (same with Wine 1.9.24).
#   Fix link to Wikipedia picture.
#   Add (right click) link to readme.html
#   Add a link to HardwareSetup.exe
#   Half standardize the NoCD warning.
# Dadu042 (2019-08-01)
#   Wine 2.22 -> 3.0.3
# Dadu042 (2020-06-03) 
#   New script (allow install from local .EXE)
#   32 bits -> 64 bits
#   Wine 3.0.3 -> 4.0.4
#
# KNOWN ISSUES :
#  - Wine x86 4.0.4, 5.0: X
#
# KNOWN ISSUES (FIXED):
#  - AMD GPU (Vega 11) + Wine amd64 3.0.3, 4.0.4, 4.21, 5.0: crash when launched 'd3dcompiler:compile_shader Compilation target "fx_2_0" not yet supported'
#    Tried: d3dx9_43 + compiler. Fix: install component 'directx9'.
#
   
[ "$PLAYONLINUX" = "" ] && exit 0
source "$PLAYONLINUX/lib/sources"
          
TITLE="Toca Race Driver 3"
PREFIX="TocaRaceDriver3"
EDITOR="Codemasters"
GAME_URL="https://en.wikipedia.org/wiki/TOCA_Race_Driver_3"
AUTHOR="Codemasters"
STEAM_ID=""
GAME_VMS="256"
SHORTCUT_FILENAME="RD3.exe"
SOFTWARE_CATEGORIES="Game;SportsGame;"
# http://wiki.playonlinux.com/index.php/Scripting_-_Chapter_9:_Standardization#Advanced_Standardization
DOCUMENT_FILE="readme.html"
         
# Starting the script
POL_SetupWindow_Init
                      
# Starting debugging API
POL_Debug_Init
     
# Open dialogue box 
POL_SetupWindow_presentation "$TITLE" "$EDITOR" "$GAME_URL" "$AUTHOR" "$PREFIX"
   
# POL_SetupWindow_message "$(eval_gettext 'WARNING: this software does exist in Linux native version.\n\nThis script only allow to run the Windows version on Linux, please prefer the Linux edition for better 3D speed.')" "$TITLE"
   
# POL_SetupWindow_message "$(eval_gettext 'This game requires a fast 3D GPU (ie: Intel HD Graphics 4440 is not enough).')" "$TITLE"
   
POL_RequiredVersion "4.3.0" || POL_Debug_Fatal "$APPLICATION_TITLE $VERSION is required to install $TITLE"
   
# Setting prefix path
POL_Wine_SelectPrefix "$PREFIX"
         
# Determine Architecture
POL_System_SetArch "amd64"
# POL_System_SetArch "x86"

Set_OS "winxp"
     
# Downloading wine if necessary and creating prefix
POL_Wine_PrefixCreate "4.0.4"
   
POL_System_TmpCreate "$PREFIX"

  
#######################################
#  Installing mandatory dependencies  #
#######################################
        
# POL_Wine_DirectInput "MouseWarpOverride" "force"

# POL_Call POL_Install_corefonts
# POL_Call POL_Install_mfc42
# POL_Call POL_Install_dsound
# POL_Call POL_Install_quartz
# POL_Call POL_Install_d3dx9_43
# POL_Call POL_Install_d3dcompiler_43
# POL_Call POL_Install_wininet
# POL_Call POL_Install_corefonts
# POL_Call POL_Install_dotnet30sp1
# POL_Call POL_Install_mono5.20
# POL_Call POL_Install_dotnet20
# POL_Call POL_Install_dotnet40
# POL_Call POL_Install_dotnet472
# POL_Call POL_Install_dsound
# POL_Call POL_Install_riched30
# POL_Call POL_Install_corefonts
# POL_Call POL_Install_d3dx11
# POL_Call POL_Install_mono210
              
              
################
#      GPU     #
################
          
# Asking about memory size of graphic card
POL_SetupWindow_VMS $GAME_VMS
           
# Set Graphic Card information keys for wine
POL_Wine_SetVideoDriver
            
# Useful for Nvidia GPUs
POL_Call POL_Install_physx
              
              
#############################################
#  Sound problem fix - pulseaudio related   #
#############################################
# [ "$POL_OS" = "Linux" ] && Set_SoundDriver "alsa"
# [ "$POL_OS" = "Linux" ] && Set_SoundEmulDriver "Y"
## End Fix
           
          
#######################################
#  Main part of this script           #
#######################################
              
# Choose between Steam and other Digital Download versions
# POL_SetupWindow_InstallMethod "STEAM,DVD,LOCAL,DOWNLOAD"
POL_SetupWindow_InstallMethod "DVD,LOCAL"
   
# POL_SetupWindow_message "Warning: do not install DirectX (nor the icons)." "$TITLE"
# POL_SetupWindow_message "Warning: do not install Visual C++ 2013 redistribuable\n nor Direct X." "$TITLE"
           
# Begin game installation
if [ "$INSTALL_METHOD" == "STEAM" ]; then
        POL_Call POL_Install_steam
        # Mandatory pre-install fix for steam
        POL_Call POL_Install_steam_flags "$STEAM_ID"
        # Shortcut done before install for steam version
        POL_Shortcut "steam.exe" "$TITLE" "" "steam://rungameid/$STEAM_ID"
        # Steam install
        POL_SetupWindow_message "$(eval_gettext 'When $TITLE download by Steam is finished,\nDo NOT click on Play.\n\nClose COMPLETELY the Steam interface, \nso that the installation script can continue')" "$TITLE"
        cd "$WINEPREFIX/drive_c/$PROGRAMFILES/Steam"
        POL_Wine start /unix "steam.exe" steam://install/$STEAM_ID
        POL_Wine_WaitExit "$TITLE"
                   
elif [ "$INSTALL_METHOD" == "DVD" ]; then
        POL_SetupWindow_cdrom
                   
        POL_Call POL_Function_NoCDWarning
            
        POL_SetupWindow_check_cdrom "RD3.ico"
        POL_Wine start /unix "$CDROM/setup.exe"
                  
        POL_Wine_WaitExit "$TITLE"
               
        # Restore screen resolution (game's default is 800x600 ?)
        # POL_Shortcut_InsertBeforeWine "$SHORTCUT" "trap 'xrandr -s 0' EXIT"
                  
        POL_Shortcut "$SHORTCUT_FILENAME" "$TITLE" "" "" "$SOFTWARE_CATEGORIES"
        POL_Shortcut_QuietDebug "$TITLE"
        POL_Shortcut_Document "$TITLE" "$DOCUMENT_FILE"

        POL_Shortcut "HardwareSetup.exe" "$TITLE (Hardware setup)" "" "" "$SOFTWARE_CATEGORIES"

elif [ "$INSTALL_METHOD" == "DOWNLOAD" ]; then
        cd "$WINEPREFIX/drive_c"
          
        # POL_SetupWindow_message "$(eval_gettext '\n\nNote: this script will download the demo .')" "$TITLE"
        POL_Download "https://archive.org/download/TheOperativeNoOneLivesForeverDemo/nolftechdemo.exe"
        
        mv nolftechdemo.exe GameInstaller.exe
        # mv Teacher%20Simulator.rar gameinstaller.rar        
        # mv Facewound.zip gameinstaller.zip
        
        # POL_SetupWindow_wait_next_signal "$(eval_gettext 'Extracting the archive...')" "$TITLE"
        # POL_System_unrar x "gameinstaller.rar" "$WINEPREFIX/drive_c/game/" || POL_Debug_Fatal "unrar is required to unarchive $TITLE (unrar package is not installed on the OS)."
        # POL_System_unzip "gameinstaller.zip" -d "$WINEPREFIX/drive_c/game/"
          
        # Extract without sub-folder.
        # unzip "gameinstaller.zip" -j -d "$WINEPREFIX/drive_c/"
          
        # POL_SetupWindow_message "$(eval_gettext 'Note: we recommend you to uncheck all the checkboxes:\n[x] -> [ ]')" "$TITLE"
  
        POL_SetupWindow_message "$(eval_gettext 'Note: just click the buttons <Unzip> then <Close>.')" "$TITLE"
      
        # cd  "$WINEPREFIX/drive_c/game/"
        POL_Wine "GameInstaller.exe" # "/SILENT"
        POL_Wine_WaitBefore "$TITLE"
  
        POL_SetupWindow_message "$(eval_gettext '\n\nNote: do NOT install DirectX.')" "$TITLE"
  
        cd  "$WINEPREFIX/drive_c/nolfdemo/"
        POL_Wine "SETUP.EXE" # "/SILENT"
        POL_Wine_WaitBefore "$TITLE"
  
        cd "$WINEPREFIX/drive_c"
        # rm GameInstaller.exe
        rm GameInstaller.exe
          
        POL_Shortcut "$SHORTCUT_FILENAME" "$TITLE" "" "" "$SOFTWARE_CATEGORIES"
        POL_Shortcut_QuietDebug "$TITLE"
          
        # Restore screen resolution (game's default is 1024x768)
        # POL_Shortcut_InsertBeforeWine "$SHORTCUT" "trap 'xrandr -s 0' EXIT"
               
        POL_Shortcut_Document "$TITLE" "$DOCUMENT_FILE"
        
          
elif [ "$INSTALL_METHOD" == "LOCAL" ]; then
        POL_SetupWindow_menu "$(eval_gettext 'What is the type of the file?.')" "$TITLE" "$(eval_gettext '.EXE')~$(eval_gettext '.ZIP')~$(eval_gettext '.RAR')" "~"
        # POL_SetupWindow_menu "$(eval_gettext 'What is the type of the file?.')" "$TITLE" "$(eval_gettext '.ZIP')~$(eval_gettext '.RAR')" "~"
        # POL_SetupWindow_menu "$(eval_gettext 'What is the type of the file?.')" "$TITLE" "$(eval_gettext '.MSI')~$(eval_gettext '.EXE')" "~"
        
        # APP_ANSWER=".EXE"
  
if [ "$APP_ANSWER" == ".EXE" ]; then
        # Asking then installing local files of the game
        cd "$HOME"
        POL_SetupWindow_browse "$(eval_gettext 'Please select the installation file (.EXE)')" "$TITLE"
        SETUP_EXE="$APP_ANSWER"

        # POL_SetupWindow_message "Note: please answer NO to all the questions that will appear." "$TITLE"

        POL_Wine start /unix "$SETUP_EXE"
        POL_Wine_WaitExit "$TITLE"
              
        # Restore screen resolution (game's default is 640x480 ?)
        # POL_Shortcut_InsertBeforeWine "$SHORTCUT" "trap 'xrandr -s 0' EXIT"
                
        POL_Shortcut "$SHORTCUT_FILENAME" "$TITLE" "" "" "$SOFTWARE_CATEGORIES"
        POL_Shortcut_QuietDebug "$TITLE"
          
        POL_Shortcut_Document "$TITLE" "$DOCUMENT_FILE"

        POL_Shortcut "HardwareSetup.exe" "$TITLE (Hardware setup)" "" "" "$SOFTWARE_CATEGORIES"   
   
elif [ "$APP_ANSWER" == "$(eval_gettext '.MSI')" ]; then
       # Asking then installing local files of the game
        cd "$HOME"
        POL_SetupWindow_browse "$(eval_gettext 'Please select the setup file to run')" "$TITLE"
        SETUP_EXE="$APP_ANSWER"
        POL_Wine msiexec /i  "$SETUP_EXE"
        POL_Wine_WaitExit "$TITLE"
                
        # Restore screen resolution (game's default is 640x480 ?)
        # POL_Shortcut_InsertBeforeWine "$SHORTCUT" "trap 'xrandr -s 0' EXIT"
                
        POL_Shortcut "$SHORTCUT_FILENAME" "$TITLE" "" "" "$SOFTWARE_CATEGORIES"
        POL_Shortcut_QuietDebug "$TITLE"
          
        POL_Shortcut_Document "$TITLE" "$DOCUMENT_FILE"
   
elif [ "$APP_ANSWER" == "$(eval_gettext '.ZIP')" ]; then
        cd "$HOME"
          
        POL_SetupWindow_message "$(eval_gettext '\n\nWARNING: the file name must not have SPACES in its name !.')" "$TITLE"
        POL_SetupWindow_browse "$(eval_gettext 'Please select the .ZIP file')" "$TITLE"
        cd "$POL_System_TmpDir"
        POL_SetupWindow_wait_next_signal "$(eval_gettext 'Extracting the archive...')" "$TITLE"
        POL_System_unzip "$APP_ANSWER" -d "$WINEPREFIX/drive_c/game/"
        
        POL_Shortcut "$SHORTCUT_FILENAME" "$TITLE" "" "" "$SOFTWARE_CATEGORIES"
          
        POL_Shortcut_Document "$TITLE" "$DOCUMENT_FILE"
        
elif [ "$APP_ANSWER" == "$(eval_gettext '.RAR')" ]; then
        cd "$HOME"
        POL_SetupWindow_browse "$(eval_gettext 'Please select the .RAR file')" "$TITLE"
        SETUP_EXE="$APP_ANSWER"
        cd "$POL_System_TmpDir"
        POL_SetupWindow_wait_next_signal "$(eval_gettext 'Extracting the archive...')" "$TITLE"
        POL_System_unrar x "$APP_ANSWER" "$WINEPREFIX/drive_c/game/" || POL_Debug_Fatal "unrar is required to unarchive $TITLE (unrar package is not installed on the OS)."
        POL_Shortcut "$SHORTCUT_FILENAME" "$TITLE" "" "" "$SOFTWARE_CATEGORIES"
         
        POL_Shortcut_Document "$TITLE" "$DOCUMENT_FILE"
   
fi
fi
 
################
# Patch update #
################
     
POL_SetupWindow_menu "$(eval_gettext 'Do you have a official patch-update to install ?')" "$TITLE" "$(eval_gettext 'No')~$(eval_gettext 'Yes')" "~"      
          
if [ "$APP_ANSWER" == "$(eval_gettext 'Yes')" ]; then
        POL_SetupWindow_browse "$(eval_gettext 'Please select the .EXE file to run')" "$TITLE"
        PATCH_EXE="$APP_ANSWER"
        POL_Wine start /unix "$PATCH_EXE"
        POL_Wine_WaitExit "$PATCH_EXE"
fi
           
# POL_SetupWindow_message "$(eval_gettext '\nInstallation is finished ! :)')" "$TITLE"
     
# POL_SetupWindow_message "$(eval_gettext 'WARNING: to avoid to have huge log file, you should type \ninto Debug flags : fixme-all')" "$TITLE"
           
# Fail ? -> yes (blank window).
# POL_SetupWindow_message "$LNG_FIN" "$TITLE"
          
POL_System_TmpDelete
POL_SetupWindow_Close
exit 0

Contributions

Filters:

Contribute
Member Message
Dadu042 Thursday 4 June 2020 at 12:27
Dadu042

Information

This update has been approved by the team.

Differences

@@ -7,7 +7,7 @@
 # Licence : Retail
 # Only For : http://www.playonlinux.com
 #
-# TESTED Editions: DVD v1.1 (hits collection 2008)
+# TESTED Editions: DVD v1.1 ? (hits collection 2008)
 #
 # Middlewares used by this software : .
 #

New source code

#!/bin/bash
# Date : (2020-06-03)
# Last revision : see the changelog below
# Wine version used : see the changelog below
# Distribution used to test : XUbuntu 18.04 64 bits
# Author : Dadu042
# Licence : Retail
# Only For : http://www.playonlinux.com
#
# TESTED Editions: DVD v1.1 ? (hits collection 2008)
#
# Middlewares used by this software : .
#
#
#
# CHANGELOG:
# thib25 (2010-01-23)
#   First script. Distribution used to test : Ubuntu 9.10.
# Dadu042 (2019-08-01)
#   Wine 1.1.35 -> 2.22 Because on Xubuntu (18.04 x64), once the retail DVD installed Wine crashed before to show anything (same with Wine 1.9.24).
#   Fix link to Wikipedia picture.
#   Add (right click) link to readme.html
#   Add a link to HardwareSetup.exe
#   Half standardize the NoCD warning.
# Dadu042 (2019-08-01)
#   Wine 2.22 -> 3.0.3
# Dadu042 (2020-06-03) 
#   New script (allow install from local .EXE)
#   32 bits -> 64 bits
#   Wine 3.0.3 -> 4.0.4
#
# KNOWN ISSUES :
#  - Wine x86 4.0.4, 5.0: X
#
# KNOWN ISSUES (FIXED):
#  - AMD GPU (Vega 11) + Wine amd64 3.0.3, 4.0.4, 4.21, 5.0: crash when launched 'd3dcompiler:compile_shader Compilation target "fx_2_0" not yet supported'
#    Tried: d3dx9_43 + compiler. Fix: install component 'directx9'.
#
   
[ "$PLAYONLINUX" = "" ] && exit 0
source "$PLAYONLINUX/lib/sources"
          
TITLE="Toca Race Driver 3"
PREFIX="TocaRaceDriver3"
EDITOR="Codemasters"
GAME_URL="https://en.wikipedia.org/wiki/TOCA_Race_Driver_3"
AUTHOR="Codemasters"
STEAM_ID=""
GAME_VMS="256"
SHORTCUT_FILENAME="RD3.exe"
SOFTWARE_CATEGORIES="Game;SportsGame;"
# http://wiki.playonlinux.com/index.php/Scripting_-_Chapter_9:_Standardization#Advanced_Standardization
DOCUMENT_FILE="readme.html"
         
# Starting the script
POL_SetupWindow_Init
                      
# Starting debugging API
POL_Debug_Init
     
# Open dialogue box 
POL_SetupWindow_presentation "$TITLE" "$EDITOR" "$GAME_URL" "$AUTHOR" "$PREFIX"
   
# POL_SetupWindow_message "$(eval_gettext 'WARNING: this software does exist in Linux native version.\n\nThis script only allow to run the Windows version on Linux, please prefer the Linux edition for better 3D speed.')" "$TITLE"
   
# POL_SetupWindow_message "$(eval_gettext 'This game requires a fast 3D GPU (ie: Intel HD Graphics 4440 is not enough).')" "$TITLE"
   
POL_RequiredVersion "4.3.0" || POL_Debug_Fatal "$APPLICATION_TITLE $VERSION is required to install $TITLE"
   
# Setting prefix path
POL_Wine_SelectPrefix "$PREFIX"
         
# Determine Architecture
POL_System_SetArch "amd64"
# POL_System_SetArch "x86"

Set_OS "winxp"
     
# Downloading wine if necessary and creating prefix
POL_Wine_PrefixCreate "4.0.4"
   
POL_System_TmpCreate "$PREFIX"

  
#######################################
#  Installing mandatory dependencies  #
#######################################
        
# POL_Wine_DirectInput "MouseWarpOverride" "force"

# POL_Call POL_Install_corefonts
# POL_Call POL_Install_mfc42
# POL_Call POL_Install_dsound
# POL_Call POL_Install_quartz
# POL_Call POL_Install_d3dx9_43
# POL_Call POL_Install_d3dcompiler_43
# POL_Call POL_Install_wininet
# POL_Call POL_Install_corefonts
# POL_Call POL_Install_dotnet30sp1
# POL_Call POL_Install_mono5.20
# POL_Call POL_Install_dotnet20
# POL_Call POL_Install_dotnet40
# POL_Call POL_Install_dotnet472
# POL_Call POL_Install_dsound
# POL_Call POL_Install_riched30
# POL_Call POL_Install_corefonts
# POL_Call POL_Install_d3dx11
# POL_Call POL_Install_mono210
              
              
################
#      GPU     #
################
          
# Asking about memory size of graphic card
POL_SetupWindow_VMS $GAME_VMS
           
# Set Graphic Card information keys for wine
POL_Wine_SetVideoDriver
            
# Useful for Nvidia GPUs
POL_Call POL_Install_physx
              
              
#############################################
#  Sound problem fix - pulseaudio related   #
#############################################
# [ "$POL_OS" = "Linux" ] && Set_SoundDriver "alsa"
# [ "$POL_OS" = "Linux" ] && Set_SoundEmulDriver "Y"
## End Fix
           
          
#######################################
#  Main part of this script           #
#######################################
              
# Choose between Steam and other Digital Download versions
# POL_SetupWindow_InstallMethod "STEAM,DVD,LOCAL,DOWNLOAD"
POL_SetupWindow_InstallMethod "DVD,LOCAL"
   
# POL_SetupWindow_message "Warning: do not install DirectX (nor the icons)." "$TITLE"
# POL_SetupWindow_message "Warning: do not install Visual C++ 2013 redistribuable\n nor Direct X." "$TITLE"
           
# Begin game installation
if [ "$INSTALL_METHOD" == "STEAM" ]; then
        POL_Call POL_Install_steam
        # Mandatory pre-install fix for steam
        POL_Call POL_Install_steam_flags "$STEAM_ID"
        # Shortcut done before install for steam version
        POL_Shortcut "steam.exe" "$TITLE" "" "steam://rungameid/$STEAM_ID"
        # Steam install
        POL_SetupWindow_message "$(eval_gettext 'When $TITLE download by Steam is finished,\nDo NOT click on Play.\n\nClose COMPLETELY the Steam interface, \nso that the installation script can continue')" "$TITLE"
        cd "$WINEPREFIX/drive_c/$PROGRAMFILES/Steam"
        POL_Wine start /unix "steam.exe" steam://install/$STEAM_ID
        POL_Wine_WaitExit "$TITLE"
                   
elif [ "$INSTALL_METHOD" == "DVD" ]; then
        POL_SetupWindow_cdrom
                   
        POL_Call POL_Function_NoCDWarning
            
        POL_SetupWindow_check_cdrom "RD3.ico"
        POL_Wine start /unix "$CDROM/setup.exe"
                  
        POL_Wine_WaitExit "$TITLE"
               
        # Restore screen resolution (game's default is 800x600 ?)
        # POL_Shortcut_InsertBeforeWine "$SHORTCUT" "trap 'xrandr -s 0' EXIT"
                  
        POL_Shortcut "$SHORTCUT_FILENAME" "$TITLE" "" "" "$SOFTWARE_CATEGORIES"
        POL_Shortcut_QuietDebug "$TITLE"
        POL_Shortcut_Document "$TITLE" "$DOCUMENT_FILE"

        POL_Shortcut "HardwareSetup.exe" "$TITLE (Hardware setup)" "" "" "$SOFTWARE_CATEGORIES"

elif [ "$INSTALL_METHOD" == "DOWNLOAD" ]; then
        cd "$WINEPREFIX/drive_c"
          
        # POL_SetupWindow_message "$(eval_gettext '\n\nNote: this script will download the demo .')" "$TITLE"
        POL_Download "https://archive.org/download/TheOperativeNoOneLivesForeverDemo/nolftechdemo.exe"
        
        mv nolftechdemo.exe GameInstaller.exe
        # mv Teacher%20Simulator.rar gameinstaller.rar        
        # mv Facewound.zip gameinstaller.zip
        
        # POL_SetupWindow_wait_next_signal "$(eval_gettext 'Extracting the archive...')" "$TITLE"
        # POL_System_unrar x "gameinstaller.rar" "$WINEPREFIX/drive_c/game/" || POL_Debug_Fatal "unrar is required to unarchive $TITLE (unrar package is not installed on the OS)."
        # POL_System_unzip "gameinstaller.zip" -d "$WINEPREFIX/drive_c/game/"
          
        # Extract without sub-folder.
        # unzip "gameinstaller.zip" -j -d "$WINEPREFIX/drive_c/"
          
        # POL_SetupWindow_message "$(eval_gettext 'Note: we recommend you to uncheck all the checkboxes:\n[x] -> [ ]')" "$TITLE"
  
        POL_SetupWindow_message "$(eval_gettext 'Note: just click the buttons <Unzip> then <Close>.')" "$TITLE"
      
        # cd  "$WINEPREFIX/drive_c/game/"
        POL_Wine "GameInstaller.exe" # "/SILENT"
        POL_Wine_WaitBefore "$TITLE"
  
        POL_SetupWindow_message "$(eval_gettext '\n\nNote: do NOT install DirectX.')" "$TITLE"
  
        cd  "$WINEPREFIX/drive_c/nolfdemo/"
        POL_Wine "SETUP.EXE" # "/SILENT"
        POL_Wine_WaitBefore "$TITLE"
  
        cd "$WINEPREFIX/drive_c"
        # rm GameInstaller.exe
        rm GameInstaller.exe
          
        POL_Shortcut "$SHORTCUT_FILENAME" "$TITLE" "" "" "$SOFTWARE_CATEGORIES"
        POL_Shortcut_QuietDebug "$TITLE"
          
        # Restore screen resolution (game's default is 1024x768)
        # POL_Shortcut_InsertBeforeWine "$SHORTCUT" "trap 'xrandr -s 0' EXIT"
               
        POL_Shortcut_Document "$TITLE" "$DOCUMENT_FILE"
        
          
elif [ "$INSTALL_METHOD" == "LOCAL" ]; then
        POL_SetupWindow_menu "$(eval_gettext 'What is the type of the file?.')" "$TITLE" "$(eval_gettext '.EXE')~$(eval_gettext '.ZIP')~$(eval_gettext '.RAR')" "~"
        # POL_SetupWindow_menu "$(eval_gettext 'What is the type of the file?.')" "$TITLE" "$(eval_gettext '.ZIP')~$(eval_gettext '.RAR')" "~"
        # POL_SetupWindow_menu "$(eval_gettext 'What is the type of the file?.')" "$TITLE" "$(eval_gettext '.MSI')~$(eval_gettext '.EXE')" "~"
        
        # APP_ANSWER=".EXE"
  
if [ "$APP_ANSWER" == ".EXE" ]; then
        # Asking then installing local files of the game
        cd "$HOME"
        POL_SetupWindow_browse "$(eval_gettext 'Please select the installation file (.EXE)')" "$TITLE"
        SETUP_EXE="$APP_ANSWER"

        # POL_SetupWindow_message "Note: please answer NO to all the questions that will appear." "$TITLE"

        POL_Wine start /unix "$SETUP_EXE"
        POL_Wine_WaitExit "$TITLE"
              
        # Restore screen resolution (game's default is 640x480 ?)
        # POL_Shortcut_InsertBeforeWine "$SHORTCUT" "trap 'xrandr -s 0' EXIT"
                
        POL_Shortcut "$SHORTCUT_FILENAME" "$TITLE" "" "" "$SOFTWARE_CATEGORIES"
        POL_Shortcut_QuietDebug "$TITLE"
          
        POL_Shortcut_Document "$TITLE" "$DOCUMENT_FILE"

        POL_Shortcut "HardwareSetup.exe" "$TITLE (Hardware setup)" "" "" "$SOFTWARE_CATEGORIES"   
   
elif [ "$APP_ANSWER" == "$(eval_gettext '.MSI')" ]; then
       # Asking then installing local files of the game
        cd "$HOME"
        POL_SetupWindow_browse "$(eval_gettext 'Please select the setup file to run')" "$TITLE"
        SETUP_EXE="$APP_ANSWER"
        POL_Wine msiexec /i  "$SETUP_EXE"
        POL_Wine_WaitExit "$TITLE"
                
        # Restore screen resolution (game's default is 640x480 ?)
        # POL_Shortcut_InsertBeforeWine "$SHORTCUT" "trap 'xrandr -s 0' EXIT"
                
        POL_Shortcut "$SHORTCUT_FILENAME" "$TITLE" "" "" "$SOFTWARE_CATEGORIES"
        POL_Shortcut_QuietDebug "$TITLE"
          
        POL_Shortcut_Document "$TITLE" "$DOCUMENT_FILE"
   
elif [ "$APP_ANSWER" == "$(eval_gettext '.ZIP')" ]; then
        cd "$HOME"
          
        POL_SetupWindow_message "$(eval_gettext '\n\nWARNING: the file name must not have SPACES in its name !.')" "$TITLE"
        POL_SetupWindow_browse "$(eval_gettext 'Please select the .ZIP file')" "$TITLE"
        cd "$POL_System_TmpDir"
        POL_SetupWindow_wait_next_signal "$(eval_gettext 'Extracting the archive...')" "$TITLE"
        POL_System_unzip "$APP_ANSWER" -d "$WINEPREFIX/drive_c/game/"
        
        POL_Shortcut "$SHORTCUT_FILENAME" "$TITLE" "" "" "$SOFTWARE_CATEGORIES"
          
        POL_Shortcut_Document "$TITLE" "$DOCUMENT_FILE"
        
elif [ "$APP_ANSWER" == "$(eval_gettext '.RAR')" ]; then
        cd "$HOME"
        POL_SetupWindow_browse "$(eval_gettext 'Please select the .RAR file')" "$TITLE"
        SETUP_EXE="$APP_ANSWER"
        cd "$POL_System_TmpDir"
        POL_SetupWindow_wait_next_signal "$(eval_gettext 'Extracting the archive...')" "$TITLE"
        POL_System_unrar x "$APP_ANSWER" "$WINEPREFIX/drive_c/game/" || POL_Debug_Fatal "unrar is required to unarchive $TITLE (unrar package is not installed on the OS)."
        POL_Shortcut "$SHORTCUT_FILENAME" "$TITLE" "" "" "$SOFTWARE_CATEGORIES"
         
        POL_Shortcut_Document "$TITLE" "$DOCUMENT_FILE"
   
fi
fi
 
################
# Patch update #
################
     
POL_SetupWindow_menu "$(eval_gettext 'Do you have a official patch-update to install ?')" "$TITLE" "$(eval_gettext 'No')~$(eval_gettext 'Yes')" "~"      
          
if [ "$APP_ANSWER" == "$(eval_gettext 'Yes')" ]; then
        POL_SetupWindow_browse "$(eval_gettext 'Please select the .EXE file to run')" "$TITLE"
        PATCH_EXE="$APP_ANSWER"
        POL_Wine start /unix "$PATCH_EXE"
        POL_Wine_WaitExit "$PATCH_EXE"
fi
           
# POL_SetupWindow_message "$(eval_gettext '\nInstallation is finished ! :)')" "$TITLE"
     
# POL_SetupWindow_message "$(eval_gettext 'WARNING: to avoid to have huge log file, you should type \ninto Debug flags : fixme-all')" "$TITLE"
           
# Fail ? -> yes (blank window).
# POL_SetupWindow_message "$LNG_FIN" "$TITLE"
          
POL_System_TmpDelete
POL_SetupWindow_Close
exit 0

Replies

Dadu042 Thursday 4 June 2020 at 12:06
Dadu042

Warning

This update has not been approved yet by the team.
Use it at your own risk

Differences

@@ -30,11 +30,11 @@
 #   Wine 3.0.3 -> 4.0.4
 #
 # KNOWN ISSUES :
-#  - Wine x86 5.0, 5.7: X
-#
+#  - Wine x86 4.0.4, 5.0: X
 #
 # KNOWN ISSUES (FIXED):
-#  - Wine x86 4.0.4, 5.0: X
+#  - AMD GPU (Vega 11) + Wine amd64 3.0.3, 4.0.4, 4.21, 5.0: crash when launched 'd3dcompiler:compile_shader Compilation target "fx_2_0" not yet supported'
+#    Tried: d3dx9_43 + compiler. Fix: install component 'directx9'.
 #
    
 [ "$PLAYONLINUX" = "" ] && exit 0
@@ -73,13 +73,14 @@
 # Determine Architecture
 POL_System_SetArch "amd64"
 # POL_System_SetArch "x86"
+
+Set_OS "winxp"
      
 # Downloading wine if necessary and creating prefix
 POL_Wine_PrefixCreate "4.0.4"
    
 POL_System_TmpCreate "$PREFIX"
-          
-Set_OS "winxp"
+
   
 #######################################
 #  Installing mandatory dependencies  #
@@ -304,8 +305,8 @@
      
 # POL_SetupWindow_message "$(eval_gettext 'WARNING: to avoid to have huge log file, you should type \ninto Debug flags : fixme-all')" "$TITLE"
            
-# Fail ?
-POL_SetupWindow_message "$LNG_FIN" "$TITLE"
+# Fail ? -> yes (blank window).
+# POL_SetupWindow_message "$LNG_FIN" "$TITLE"
           
 POL_System_TmpDelete
 POL_SetupWindow_Close

New source code

#!/bin/bash
# Date : (2020-06-03)
# Last revision : see the changelog below
# Wine version used : see the changelog below
# Distribution used to test : XUbuntu 18.04 64 bits
# Author : Dadu042
# Licence : Retail
# Only For : http://www.playonlinux.com
#
# TESTED Editions: DVD v1.1 (hits collection 2008)
#
# Middlewares used by this software : .
#
#
#
# CHANGELOG:
# thib25 (2010-01-23)
#   First script. Distribution used to test : Ubuntu 9.10.
# Dadu042 (2019-08-01)
#   Wine 1.1.35 -> 2.22 Because on Xubuntu (18.04 x64), once the retail DVD installed Wine crashed before to show anything (same with Wine 1.9.24).
#   Fix link to Wikipedia picture.
#   Add (right click) link to readme.html
#   Add a link to HardwareSetup.exe
#   Half standardize the NoCD warning.
# Dadu042 (2019-08-01)
#   Wine 2.22 -> 3.0.3
# Dadu042 (2020-06-03) 
#   New script (allow install from local .EXE)
#   32 bits -> 64 bits
#   Wine 3.0.3 -> 4.0.4
#
# KNOWN ISSUES :
#  - Wine x86 4.0.4, 5.0: X
#
# KNOWN ISSUES (FIXED):
#  - AMD GPU (Vega 11) + Wine amd64 3.0.3, 4.0.4, 4.21, 5.0: crash when launched 'd3dcompiler:compile_shader Compilation target "fx_2_0" not yet supported'
#    Tried: d3dx9_43 + compiler. Fix: install component 'directx9'.
#
   
[ "$PLAYONLINUX" = "" ] && exit 0
source "$PLAYONLINUX/lib/sources"
          
TITLE="Toca Race Driver 3"
PREFIX="TocaRaceDriver3"
EDITOR="Codemasters"
GAME_URL="https://en.wikipedia.org/wiki/TOCA_Race_Driver_3"
AUTHOR="Codemasters"
STEAM_ID=""
GAME_VMS="256"
SHORTCUT_FILENAME="RD3.exe"
SOFTWARE_CATEGORIES="Game;SportsGame;"
# http://wiki.playonlinux.com/index.php/Scripting_-_Chapter_9:_Standardization#Advanced_Standardization
DOCUMENT_FILE="readme.html"
         
# Starting the script
POL_SetupWindow_Init
                      
# Starting debugging API
POL_Debug_Init
     
# Open dialogue box 
POL_SetupWindow_presentation "$TITLE" "$EDITOR" "$GAME_URL" "$AUTHOR" "$PREFIX"
   
# POL_SetupWindow_message "$(eval_gettext 'WARNING: this software does exist in Linux native version.\n\nThis script only allow to run the Windows version on Linux, please prefer the Linux edition for better 3D speed.')" "$TITLE"
   
# POL_SetupWindow_message "$(eval_gettext 'This game requires a fast 3D GPU (ie: Intel HD Graphics 4440 is not enough).')" "$TITLE"
   
POL_RequiredVersion "4.3.0" || POL_Debug_Fatal "$APPLICATION_TITLE $VERSION is required to install $TITLE"
   
# Setting prefix path
POL_Wine_SelectPrefix "$PREFIX"
         
# Determine Architecture
POL_System_SetArch "amd64"
# POL_System_SetArch "x86"

Set_OS "winxp"
     
# Downloading wine if necessary and creating prefix
POL_Wine_PrefixCreate "4.0.4"
   
POL_System_TmpCreate "$PREFIX"

  
#######################################
#  Installing mandatory dependencies  #
#######################################
        
# POL_Wine_DirectInput "MouseWarpOverride" "force"

# POL_Call POL_Install_corefonts
# POL_Call POL_Install_mfc42
# POL_Call POL_Install_dsound
# POL_Call POL_Install_quartz
# POL_Call POL_Install_d3dx9_43
# POL_Call POL_Install_d3dcompiler_43
# POL_Call POL_Install_wininet
# POL_Call POL_Install_corefonts
# POL_Call POL_Install_dotnet30sp1
# POL_Call POL_Install_mono5.20
# POL_Call POL_Install_dotnet20
# POL_Call POL_Install_dotnet40
# POL_Call POL_Install_dotnet472
# POL_Call POL_Install_dsound
# POL_Call POL_Install_riched30
# POL_Call POL_Install_corefonts
# POL_Call POL_Install_d3dx11
# POL_Call POL_Install_mono210
              
              
################
#      GPU     #
################
          
# Asking about memory size of graphic card
POL_SetupWindow_VMS $GAME_VMS
           
# Set Graphic Card information keys for wine
POL_Wine_SetVideoDriver
            
# Useful for Nvidia GPUs
POL_Call POL_Install_physx
              
              
#############################################
#  Sound problem fix - pulseaudio related   #
#############################################
# [ "$POL_OS" = "Linux" ] && Set_SoundDriver "alsa"
# [ "$POL_OS" = "Linux" ] && Set_SoundEmulDriver "Y"
## End Fix
           
          
#######################################
#  Main part of this script           #
#######################################
              
# Choose between Steam and other Digital Download versions
# POL_SetupWindow_InstallMethod "STEAM,DVD,LOCAL,DOWNLOAD"
POL_SetupWindow_InstallMethod "DVD,LOCAL"
   
# POL_SetupWindow_message "Warning: do not install DirectX (nor the icons)." "$TITLE"
# POL_SetupWindow_message "Warning: do not install Visual C++ 2013 redistribuable\n nor Direct X." "$TITLE"
           
# Begin game installation
if [ "$INSTALL_METHOD" == "STEAM" ]; then
        POL_Call POL_Install_steam
        # Mandatory pre-install fix for steam
        POL_Call POL_Install_steam_flags "$STEAM_ID"
        # Shortcut done before install for steam version
        POL_Shortcut "steam.exe" "$TITLE" "" "steam://rungameid/$STEAM_ID"
        # Steam install
        POL_SetupWindow_message "$(eval_gettext 'When $TITLE download by Steam is finished,\nDo NOT click on Play.\n\nClose COMPLETELY the Steam interface, \nso that the installation script can continue')" "$TITLE"
        cd "$WINEPREFIX/drive_c/$PROGRAMFILES/Steam"
        POL_Wine start /unix "steam.exe" steam://install/$STEAM_ID
        POL_Wine_WaitExit "$TITLE"
                   
elif [ "$INSTALL_METHOD" == "DVD" ]; then
        POL_SetupWindow_cdrom
                   
        POL_Call POL_Function_NoCDWarning
            
        POL_SetupWindow_check_cdrom "RD3.ico"
        POL_Wine start /unix "$CDROM/setup.exe"
                  
        POL_Wine_WaitExit "$TITLE"
               
        # Restore screen resolution (game's default is 800x600 ?)
        # POL_Shortcut_InsertBeforeWine "$SHORTCUT" "trap 'xrandr -s 0' EXIT"
                  
        POL_Shortcut "$SHORTCUT_FILENAME" "$TITLE" "" "" "$SOFTWARE_CATEGORIES"
        POL_Shortcut_QuietDebug "$TITLE"
        POL_Shortcut_Document "$TITLE" "$DOCUMENT_FILE"

        POL_Shortcut "HardwareSetup.exe" "$TITLE (Hardware setup)" "" "" "$SOFTWARE_CATEGORIES"

elif [ "$INSTALL_METHOD" == "DOWNLOAD" ]; then
        cd "$WINEPREFIX/drive_c"
          
        # POL_SetupWindow_message "$(eval_gettext '\n\nNote: this script will download the demo .')" "$TITLE"
        POL_Download "https://archive.org/download/TheOperativeNoOneLivesForeverDemo/nolftechdemo.exe"
        
        mv nolftechdemo.exe GameInstaller.exe
        # mv Teacher%20Simulator.rar gameinstaller.rar        
        # mv Facewound.zip gameinstaller.zip
        
        # POL_SetupWindow_wait_next_signal "$(eval_gettext 'Extracting the archive...')" "$TITLE"
        # POL_System_unrar x "gameinstaller.rar" "$WINEPREFIX/drive_c/game/" || POL_Debug_Fatal "unrar is required to unarchive $TITLE (unrar package is not installed on the OS)."
        # POL_System_unzip "gameinstaller.zip" -d "$WINEPREFIX/drive_c/game/"
          
        # Extract without sub-folder.
        # unzip "gameinstaller.zip" -j -d "$WINEPREFIX/drive_c/"
          
        # POL_SetupWindow_message "$(eval_gettext 'Note: we recommend you to uncheck all the checkboxes:\n[x] -> [ ]')" "$TITLE"
  
        POL_SetupWindow_message "$(eval_gettext 'Note: just click the buttons <Unzip> then <Close>.')" "$TITLE"
      
        # cd  "$WINEPREFIX/drive_c/game/"
        POL_Wine "GameInstaller.exe" # "/SILENT"
        POL_Wine_WaitBefore "$TITLE"
  
        POL_SetupWindow_message "$(eval_gettext '\n\nNote: do NOT install DirectX.')" "$TITLE"
  
        cd  "$WINEPREFIX/drive_c/nolfdemo/"
        POL_Wine "SETUP.EXE" # "/SILENT"
        POL_Wine_WaitBefore "$TITLE"
  
        cd "$WINEPREFIX/drive_c"
        # rm GameInstaller.exe
        rm GameInstaller.exe
          
        POL_Shortcut "$SHORTCUT_FILENAME" "$TITLE" "" "" "$SOFTWARE_CATEGORIES"
        POL_Shortcut_QuietDebug "$TITLE"
          
        # Restore screen resolution (game's default is 1024x768)
        # POL_Shortcut_InsertBeforeWine "$SHORTCUT" "trap 'xrandr -s 0' EXIT"
               
        POL_Shortcut_Document "$TITLE" "$DOCUMENT_FILE"
        
          
elif [ "$INSTALL_METHOD" == "LOCAL" ]; then
        POL_SetupWindow_menu "$(eval_gettext 'What is the type of the file?.')" "$TITLE" "$(eval_gettext '.EXE')~$(eval_gettext '.ZIP')~$(eval_gettext '.RAR')" "~"
        # POL_SetupWindow_menu "$(eval_gettext 'What is the type of the file?.')" "$TITLE" "$(eval_gettext '.ZIP')~$(eval_gettext '.RAR')" "~"
        # POL_SetupWindow_menu "$(eval_gettext 'What is the type of the file?.')" "$TITLE" "$(eval_gettext '.MSI')~$(eval_gettext '.EXE')" "~"
        
        # APP_ANSWER=".EXE"
  
if [ "$APP_ANSWER" == ".EXE" ]; then
        # Asking then installing local files of the game
        cd "$HOME"
        POL_SetupWindow_browse "$(eval_gettext 'Please select the installation file (.EXE)')" "$TITLE"
        SETUP_EXE="$APP_ANSWER"

        # POL_SetupWindow_message "Note: please answer NO to all the questions that will appear." "$TITLE"

        POL_Wine start /unix "$SETUP_EXE"
        POL_Wine_WaitExit "$TITLE"
              
        # Restore screen resolution (game's default is 640x480 ?)
        # POL_Shortcut_InsertBeforeWine "$SHORTCUT" "trap 'xrandr -s 0' EXIT"
                
        POL_Shortcut "$SHORTCUT_FILENAME" "$TITLE" "" "" "$SOFTWARE_CATEGORIES"
        POL_Shortcut_QuietDebug "$TITLE"
          
        POL_Shortcut_Document "$TITLE" "$DOCUMENT_FILE"

        POL_Shortcut "HardwareSetup.exe" "$TITLE (Hardware setup)" "" "" "$SOFTWARE_CATEGORIES"   
   
elif [ "$APP_ANSWER" == "$(eval_gettext '.MSI')" ]; then
       # Asking then installing local files of the game
        cd "$HOME"
        POL_SetupWindow_browse "$(eval_gettext 'Please select the setup file to run')" "$TITLE"
        SETUP_EXE="$APP_ANSWER"
        POL_Wine msiexec /i  "$SETUP_EXE"
        POL_Wine_WaitExit "$TITLE"
                
        # Restore screen resolution (game's default is 640x480 ?)
        # POL_Shortcut_InsertBeforeWine "$SHORTCUT" "trap 'xrandr -s 0' EXIT"
                
        POL_Shortcut "$SHORTCUT_FILENAME" "$TITLE" "" "" "$SOFTWARE_CATEGORIES"
        POL_Shortcut_QuietDebug "$TITLE"
          
        POL_Shortcut_Document "$TITLE" "$DOCUMENT_FILE"
   
elif [ "$APP_ANSWER" == "$(eval_gettext '.ZIP')" ]; then
        cd "$HOME"
          
        POL_SetupWindow_message "$(eval_gettext '\n\nWARNING: the file name must not have SPACES in its name !.')" "$TITLE"
        POL_SetupWindow_browse "$(eval_gettext 'Please select the .ZIP file')" "$TITLE"
        cd "$POL_System_TmpDir"
        POL_SetupWindow_wait_next_signal "$(eval_gettext 'Extracting the archive...')" "$TITLE"
        POL_System_unzip "$APP_ANSWER" -d "$WINEPREFIX/drive_c/game/"
        
        POL_Shortcut "$SHORTCUT_FILENAME" "$TITLE" "" "" "$SOFTWARE_CATEGORIES"
          
        POL_Shortcut_Document "$TITLE" "$DOCUMENT_FILE"
        
elif [ "$APP_ANSWER" == "$(eval_gettext '.RAR')" ]; then
        cd "$HOME"
        POL_SetupWindow_browse "$(eval_gettext 'Please select the .RAR file')" "$TITLE"
        SETUP_EXE="$APP_ANSWER"
        cd "$POL_System_TmpDir"
        POL_SetupWindow_wait_next_signal "$(eval_gettext 'Extracting the archive...')" "$TITLE"
        POL_System_unrar x "$APP_ANSWER" "$WINEPREFIX/drive_c/game/" || POL_Debug_Fatal "unrar is required to unarchive $TITLE (unrar package is not installed on the OS)."
        POL_Shortcut "$SHORTCUT_FILENAME" "$TITLE" "" "" "$SOFTWARE_CATEGORIES"
         
        POL_Shortcut_Document "$TITLE" "$DOCUMENT_FILE"
   
fi
fi
 
################
# Patch update #
################
     
POL_SetupWindow_menu "$(eval_gettext 'Do you have a official patch-update to install ?')" "$TITLE" "$(eval_gettext 'No')~$(eval_gettext 'Yes')" "~"      
          
if [ "$APP_ANSWER" == "$(eval_gettext 'Yes')" ]; then
        POL_SetupWindow_browse "$(eval_gettext 'Please select the .EXE file to run')" "$TITLE"
        PATCH_EXE="$APP_ANSWER"
        POL_Wine start /unix "$PATCH_EXE"
        POL_Wine_WaitExit "$PATCH_EXE"
fi
           
# POL_SetupWindow_message "$(eval_gettext '\nInstallation is finished ! :)')" "$TITLE"
     
# POL_SetupWindow_message "$(eval_gettext 'WARNING: to avoid to have huge log file, you should type \ninto Debug flags : fixme-all')" "$TITLE"
           
# Fail ? -> yes (blank window).
# POL_SetupWindow_message "$LNG_FIN" "$TITLE"
          
POL_System_TmpDelete
POL_SetupWindow_Close
exit 0

Replies

Dadu042 Thursday 4 June 2020 at 10:48
Dadu042

Warning

This update has not been approved yet by the team.
Use it at your own risk

Differences

@@ -1,10 +1,17 @@
 #!/bin/bash
-# Date : (2010-01-23  20-30)
-# Last revision : See changelog
-# Wine version used : 3.0.3
-# Distribution used to test : Xubuntu 18.04 x64
-# Author : thib25
-# Licence : Retail 
+# Date : (2020-06-03)
+# Last revision : see the changelog below
+# Wine version used : see the changelog below
+# Distribution used to test : XUbuntu 18.04 64 bits
+# Author : Dadu042
+# Licence : Retail
+# Only For : http://www.playonlinux.com
+#
+# TESTED Editions: DVD v1.1 (hits collection 2008)
+#
+# Middlewares used by this software : .
+#
+#
 #
 # CHANGELOG:
 # thib25 (2010-01-23)
@@ -17,78 +24,289 @@
 #   Half standardize the NoCD warning.
 # Dadu042 (2019-08-01)
 #   Wine 2.22 -> 3.0.3
+# Dadu042 (2020-06-03) 
+#   New script (allow install from local .EXE)
+#   32 bits -> 64 bits
+#   Wine 3.0.3 -> 4.0.4
 #
-# KNOWN ISSUES:
-# 
-
+# KNOWN ISSUES :
+#  - Wine x86 5.0, 5.7: X
+#
+#
+# KNOWN ISSUES (FIXED):
+#  - Wine x86 4.0.4, 5.0: X
+#
+   
 [ "$PLAYONLINUX" = "" ] && exit 0
 source "$PLAYONLINUX/lib/sources"
-
+          
 TITLE="Toca Race Driver 3"
-NAME="Toca Race Driver 3"
-PREFIX="TRD3"
-WORKING_WINE_VERSION="3.0.3"
-
-if [ "$POL_LANG" == "fr" ]; then
-	INSTALLATION="Installation en cours..."
-	ATTENTION="Veuillez noter que ce jeu a une protection anti-copie
-	et que malheuresement, cela empêche wine de lancer le jeu.
- 
-	PlayOnLinux ne fournira aucune aide concernant tout travail illégal."
-	ATTENTIONT="Note à propos de la protection anti-copie"
-	POLEND="$NAME a été installé avec succès."
-else
-	INSTALLATION="Installation in progress..."
-	ATTENTION="Please note that this game has a copy protection system
-	and sadly, it prevents Wine from running the game.
- 
-	PlayOnLinux will not provide any help concerning any illegal stuff."
-	ATTENTIONT="Note about copy protection"
-	POLEND="$NAME has been installed succesfully."
-fi
+PREFIX="TocaRaceDriver3"
+EDITOR="Codemasters"
+GAME_URL="https://en.wikipedia.org/wiki/TOCA_Race_Driver_3"
+AUTHOR="Codemasters"
+STEAM_ID=""
+GAME_VMS="256"
+SHORTCUT_FILENAME="RD3.exe"
+SOFTWARE_CATEGORIES="Game;SportsGame;"
+# http://wiki.playonlinux.com/index.php/Scripting_-_Chapter_9:_Standardization#Advanced_Standardization
+DOCUMENT_FILE="readme.html"
+         
+# Starting the script
+POL_SetupWindow_Init
+                      
+# Starting debugging API
+POL_Debug_Init
+     
+# Open dialogue box 
+POL_SetupWindow_presentation "$TITLE" "$EDITOR" "$GAME_URL" "$AUTHOR" "$PREFIX"
+   
+# POL_SetupWindow_message "$(eval_gettext 'WARNING: this software does exist in Linux native version.\n\nThis script only allow to run the Windows version on Linux, please prefer the Linux edition for better 3D speed.')" "$TITLE"
+   
+# POL_SetupWindow_message "$(eval_gettext 'This game requires a fast 3D GPU (ie: Intel HD Graphics 4440 is not enough).')" "$TITLE"
+   
+POL_RequiredVersion "4.3.0" || POL_Debug_Fatal "$APPLICATION_TITLE $VERSION is required to install $TITLE"
+   
+# Setting prefix path
+POL_Wine_SelectPrefix "$PREFIX"
+         
+# Determine Architecture
+POL_System_SetArch "amd64"
+# POL_System_SetArch "x86"
+     
+# Downloading wine if necessary and creating prefix
+POL_Wine_PrefixCreate "4.0.4"
+   
+POL_System_TmpCreate "$PREFIX"
+          
+Set_OS "winxp"
+  
+#######################################
+#  Installing mandatory dependencies  #
+#######################################
+	
+# POL_Wine_DirectInput "MouseWarpOverride" "force"
 
+# POL_Call POL_Install_corefonts
+# POL_Call POL_Install_mfc42
+# POL_Call POL_Install_dsound
+# POL_Call POL_Install_quartz
+# POL_Call POL_Install_d3dx9_43
+# POL_Call POL_Install_d3dcompiler_43
+# POL_Call POL_Install_wininet
+# POL_Call POL_Install_corefonts
+# POL_Call POL_Install_dotnet30sp1
+# POL_Call POL_Install_mono5.20
+# POL_Call POL_Install_dotnet20
+# POL_Call POL_Install_dotnet40
+# POL_Call POL_Install_dotnet472
+# POL_Call POL_Install_dsound
+# POL_Call POL_Install_riched30
+# POL_Call POL_Install_corefonts
+# POL_Call POL_Install_d3dx11
+# POL_Call POL_Install_mono210
+              
+              
+################
+#      GPU     #
+################
+          
+# Asking about memory size of graphic card
+POL_SetupWindow_VMS $GAME_VMS
+           
+# Set Graphic Card information keys for wine
+POL_Wine_SetVideoDriver
+            
+# Useful for Nvidia GPUs
+POL_Call POL_Install_physx
+              
+              
+#############################################
+#  Sound problem fix - pulseaudio related   #
+#############################################
+# [ "$POL_OS" = "Linux" ] && Set_SoundDriver "alsa"
+# [ "$POL_OS" = "Linux" ] && Set_SoundEmulDriver "Y"
+## End Fix
+           
+          
+#######################################
+#  Main part of this script           #
+#######################################
+              
+# Choose between Steam and other Digital Download versions
+# POL_SetupWindow_InstallMethod "STEAM,DVD,LOCAL,DOWNLOAD"
+POL_SetupWindow_InstallMethod "DVD,LOCAL"
+   
+# POL_SetupWindow_message "Warning: do not install DirectX (nor the icons)." "$TITLE"
+# POL_SetupWindow_message "Warning: do not install Visual C++ 2013 redistribuable\n nor Direct X." "$TITLE"
+           
+# Begin game installation
+if [ "$INSTALL_METHOD" == "STEAM" ]; then
+        POL_Call POL_Install_steam
+        # Mandatory pre-install fix for steam
+        POL_Call POL_Install_steam_flags "$STEAM_ID"
+        # Shortcut done before install for steam version
+        POL_Shortcut "steam.exe" "$TITLE" "" "steam://rungameid/$STEAM_ID"
+        # Steam install
+        POL_SetupWindow_message "$(eval_gettext 'When $TITLE download by Steam is finished,\nDo NOT click on Play.\n\nClose COMPLETELY the Steam interface, \nso that the installation script can continue')" "$TITLE"
+        cd "$WINEPREFIX/drive_c/$PROGRAMFILES/Steam"
+        POL_Wine start /unix "steam.exe" steam://install/$STEAM_ID
+        POL_Wine_WaitExit "$TITLE"
+                   
+elif [ "$INSTALL_METHOD" == "DVD" ]; then
+        POL_SetupWindow_cdrom
+                   
+        POL_Call POL_Function_NoCDWarning
+            
+        POL_SetupWindow_check_cdrom "RD3.ico"
+        POL_Wine start /unix "$CDROM/setup.exe"
+                  
+        POL_Wine_WaitExit "$TITLE"
+               
+        # Restore screen resolution (game's default is 800x600 ?)
+        # POL_Shortcut_InsertBeforeWine "$SHORTCUT" "trap 'xrandr -s 0' EXIT"
+                  
+        POL_Shortcut "$SHORTCUT_FILENAME" "$TITLE" "" "" "$SOFTWARE_CATEGORIES"
+        POL_Shortcut_QuietDebug "$TITLE"
+        POL_Shortcut_Document "$TITLE" "$DOCUMENT_FILE"
 
-wget https://upload.wikimedia.org/wikipedia/en/f/f0/TOCA_Race_Driver_3_Cover.jpg --output-document="$REPERTOIRE/tmp/leftnotscaled.jpeg"
-convert "$REPERTOIRE/tmp/leftnotscaled.jpeg" -scale 150x356\! "$REPERTOIRE/tmp/left.jpeg"
-POL_SetupWindow_Init "" "$REPERTOIRE/tmp/left.jpeg"
-  
-POL_SetupWindow_presentation "$NAME" "Codemasters" "http://www.codemasters.com/tocaracedriver3/" "thib25" "$PREFIX"
-
-if [ "$POL_LANG" == "fr" ]; then
-	POL_SetupWindow_message_image "$ATTENTION" "$ATTENTIONT" "$PLAYONLINUX/themes/tango/warning.png"
-	# POL_Call POL_Function_NoCDWarning
-else
-	# POL_SetupWindow_message_image "$ATTENTION" "$ATTENTIONT" "$PLAYONLINUX/themes/tango/warning.png"
-	POL_Call POL_Function_NoCDWarning
-fi
+        POL_Shortcut "HardwareSetup.exe" "$TITLE (Hardware setup)" "" "" "$SOFTWARE_CATEGORIES"
+
+elif [ "$INSTALL_METHOD" == "DOWNLOAD" ]; then
+        cd "$WINEPREFIX/drive_c"
+          
+        # POL_SetupWindow_message "$(eval_gettext '\n\nNote: this script will download the demo .')" "$TITLE"
+        POL_Download "https://archive.org/download/TheOperativeNoOneLivesForeverDemo/nolftechdemo.exe"
+        
+        mv nolftechdemo.exe GameInstaller.exe
+        # mv Teacher%20Simulator.rar gameinstaller.rar        
+        # mv Facewound.zip gameinstaller.zip
+        
+        # POL_SetupWindow_wait_next_signal "$(eval_gettext 'Extracting the archive...')" "$TITLE"
+        # POL_System_unrar x "gameinstaller.rar" "$WINEPREFIX/drive_c/game/" || POL_Debug_Fatal "unrar is required to unarchive $TITLE (unrar package is not installed on the OS)."
+        # POL_System_unzip "gameinstaller.zip" -d "$WINEPREFIX/drive_c/game/"
+          
+        # Extract without sub-folder.
+        # unzip "gameinstaller.zip" -j -d "$WINEPREFIX/drive_c/"
+          
+        # POL_SetupWindow_message "$(eval_gettext 'Note: we recommend you to uncheck all the checkboxes:\n[x] -> [ ]')" "$TITLE"
   
-POL_SetupWindow_cdrom
-POL_SetupWindow_check_cdrom "RD3.ico"
+        POL_SetupWindow_message "$(eval_gettext 'Note: just click the buttons <Unzip> then <Close>.')" "$TITLE"
+      
+        # cd  "$WINEPREFIX/drive_c/game/"
+        POL_Wine "GameInstaller.exe" # "/SILENT"
+        POL_Wine_WaitBefore "$TITLE"
   
-select_prefix "$REPERTOIRE/wineprefix/$PREFIX"
-POL_SetupWindow_prefixcreate
- 
-PROGRAMFILES=`wine cmd /c echo "%ProgramFiles%" |tr -d '\015' | tr -d '\010'`
-PROGRAMFILES=${PROGRAMFILES:3}
+        POL_SetupWindow_message "$(eval_gettext '\n\nNote: do NOT install DirectX.')" "$TITLE"
   
-POL_SetupWindow_wait_next_signal "$INSTALLATION" "$NAME"
-wine "$CDROM/setup.exe"
-POL_SetupWindow_detect_exit
+        cd  "$WINEPREFIX/drive_c/nolfdemo/"
+        POL_Wine "SETUP.EXE" # "/SILENT"
+        POL_Wine_WaitBefore "$TITLE"
   
-# Make custom Icon
-convert "$CDROM/RD3.ico" -geometry 32x32 "$REPERTOIRE/icones/32/$NAME"
+        cd "$WINEPREFIX/drive_c"
+        # rm GameInstaller.exe
+        rm GameInstaller.exe
+          
+        POL_Shortcut "$SHORTCUT_FILENAME" "$TITLE" "" "" "$SOFTWARE_CATEGORIES"
+        POL_Shortcut_QuietDebug "$TITLE"
+          
+        # Restore screen resolution (game's default is 1024x768)
+        # POL_Shortcut_InsertBeforeWine "$SHORTCUT" "trap 'xrandr -s 0' EXIT"
+               
+        POL_Shortcut_Document "$TITLE" "$DOCUMENT_FILE"
+        
+          
+elif [ "$INSTALL_METHOD" == "LOCAL" ]; then
+        POL_SetupWindow_menu "$(eval_gettext 'What is the type of the file?.')" "$TITLE" "$(eval_gettext '.EXE')~$(eval_gettext '.ZIP')~$(eval_gettext '.RAR')" "~"
+        # POL_SetupWindow_menu "$(eval_gettext 'What is the type of the file?.')" "$TITLE" "$(eval_gettext '.ZIP')~$(eval_gettext '.RAR')" "~"
+        # POL_SetupWindow_menu "$(eval_gettext 'What is the type of the file?.')" "$TITLE" "$(eval_gettext '.MSI')~$(eval_gettext '.EXE')" "~"
+        
+        # APP_ANSWER=".EXE"
   
-POL_SetupWindow_make_shortcut "$PREFIX" "$PROGRAMFILES/Codemasters/Race Driver 3" "RD3.exe" "$NAME" "$NAME"
-POL_Shortcut_Document "$NAME" "readme.html"
-POL_Shortcut "HardwareSetup.exe" "$NAME (Hardware setup)" ""
+if [ "$APP_ANSWER" == ".EXE" ]; then
+        # Asking then installing local files of the game
+        cd "$HOME"
+        POL_SetupWindow_browse "$(eval_gettext 'Please select the installation file (.EXE)')" "$TITLE"
+        SETUP_EXE="$APP_ANSWER"
 
-POL_SetupWindow_install_wine "3.0.3"
-Set_WineVersion_Assign "3.0.3" "$NAME"
+	# POL_SetupWindow_message "Note: please answer NO to all the questions that will appear." "$TITLE"
 
-# Select GPU (if there are 2)
-POL_Call POL_Install_VideoDriver
-
-POL_SetupWindow_message "$POLEND" "$NAME"
+        POL_Wine start /unix "$SETUP_EXE"
+        POL_Wine_WaitExit "$TITLE"
+              
+        # Restore screen resolution (game's default is 640x480 ?)
+        # POL_Shortcut_InsertBeforeWine "$SHORTCUT" "trap 'xrandr -s 0' EXIT"
+                
+        POL_Shortcut "$SHORTCUT_FILENAME" "$TITLE" "" "" "$SOFTWARE_CATEGORIES"
+        POL_Shortcut_QuietDebug "$TITLE"
+          
+        POL_Shortcut_Document "$TITLE" "$DOCUMENT_FILE"
 
+        POL_Shortcut "HardwareSetup.exe" "$TITLE (Hardware setup)" "" "" "$SOFTWARE_CATEGORIES"   
+   
+elif [ "$APP_ANSWER" == "$(eval_gettext '.MSI')" ]; then
+       # Asking then installing local files of the game
+        cd "$HOME"
+        POL_SetupWindow_browse "$(eval_gettext 'Please select the setup file to run')" "$TITLE"
+        SETUP_EXE="$APP_ANSWER"
+        POL_Wine msiexec /i  "$SETUP_EXE"
+        POL_Wine_WaitExit "$TITLE"
+                
+        # Restore screen resolution (game's default is 640x480 ?)
+        # POL_Shortcut_InsertBeforeWine "$SHORTCUT" "trap 'xrandr -s 0' EXIT"
+                
+        POL_Shortcut "$SHORTCUT_FILENAME" "$TITLE" "" "" "$SOFTWARE_CATEGORIES"
+        POL_Shortcut_QuietDebug "$TITLE"
+          
+        POL_Shortcut_Document "$TITLE" "$DOCUMENT_FILE"
+   
+elif [ "$APP_ANSWER" == "$(eval_gettext '.ZIP')" ]; then
+        cd "$HOME"
+          
+        POL_SetupWindow_message "$(eval_gettext '\n\nWARNING: the file name must not have SPACES in its name !.')" "$TITLE"
+        POL_SetupWindow_browse "$(eval_gettext 'Please select the .ZIP file')" "$TITLE"
+        cd "$POL_System_TmpDir"
+        POL_SetupWindow_wait_next_signal "$(eval_gettext 'Extracting the archive...')" "$TITLE"
+        POL_System_unzip "$APP_ANSWER" -d "$WINEPREFIX/drive_c/game/"
+        
+        POL_Shortcut "$SHORTCUT_FILENAME" "$TITLE" "" "" "$SOFTWARE_CATEGORIES"
+          
+        POL_Shortcut_Document "$TITLE" "$DOCUMENT_FILE"
+        
+elif [ "$APP_ANSWER" == "$(eval_gettext '.RAR')" ]; then
+        cd "$HOME"
+        POL_SetupWindow_browse "$(eval_gettext 'Please select the .RAR file')" "$TITLE"
+        SETUP_EXE="$APP_ANSWER"
+        cd "$POL_System_TmpDir"
+        POL_SetupWindow_wait_next_signal "$(eval_gettext 'Extracting the archive...')" "$TITLE"
+        POL_System_unrar x "$APP_ANSWER" "$WINEPREFIX/drive_c/game/" || POL_Debug_Fatal "unrar is required to unarchive $TITLE (unrar package is not installed on the OS)."
+        POL_Shortcut "$SHORTCUT_FILENAME" "$TITLE" "" "" "$SOFTWARE_CATEGORIES"
+         
+        POL_Shortcut_Document "$TITLE" "$DOCUMENT_FILE"
+   
+fi
+fi
+ 
+################
+# Patch update #
+################
+     
+POL_SetupWindow_menu "$(eval_gettext 'Do you have a official patch-update to install ?')" "$TITLE" "$(eval_gettext 'No')~$(eval_gettext 'Yes')" "~"      
+          
+if [ "$APP_ANSWER" == "$(eval_gettext 'Yes')" ]; then
+        POL_SetupWindow_browse "$(eval_gettext 'Please select the .EXE file to run')" "$TITLE"
+        PATCH_EXE="$APP_ANSWER"
+        POL_Wine start /unix "$PATCH_EXE"
+        POL_Wine_WaitExit "$PATCH_EXE"
+fi
+           
+# POL_SetupWindow_message "$(eval_gettext '\nInstallation is finished ! :)')" "$TITLE"
+     
+# POL_SetupWindow_message "$(eval_gettext 'WARNING: to avoid to have huge log file, you should type \ninto Debug flags : fixme-all')" "$TITLE"
+           
+# Fail ?
+POL_SetupWindow_message "$LNG_FIN" "$TITLE"
+          
+POL_System_TmpDelete
 POL_SetupWindow_Close
-exit
\ No newline at end of file
+exit 0
\ No newline at end of file

New source code

#!/bin/bash
# Date : (2020-06-03)
# Last revision : see the changelog below
# Wine version used : see the changelog below
# Distribution used to test : XUbuntu 18.04 64 bits
# Author : Dadu042
# Licence : Retail
# Only For : http://www.playonlinux.com
#
# TESTED Editions: DVD v1.1 (hits collection 2008)
#
# Middlewares used by this software : .
#
#
#
# CHANGELOG:
# thib25 (2010-01-23)
#   First script. Distribution used to test : Ubuntu 9.10.
# Dadu042 (2019-08-01)
#   Wine 1.1.35 -> 2.22 Because on Xubuntu (18.04 x64), once the retail DVD installed Wine crashed before to show anything (same with Wine 1.9.24).
#   Fix link to Wikipedia picture.
#   Add (right click) link to readme.html
#   Add a link to HardwareSetup.exe
#   Half standardize the NoCD warning.
# Dadu042 (2019-08-01)
#   Wine 2.22 -> 3.0.3
# Dadu042 (2020-06-03) 
#   New script (allow install from local .EXE)
#   32 bits -> 64 bits
#   Wine 3.0.3 -> 4.0.4
#
# KNOWN ISSUES :
#  - Wine x86 5.0, 5.7: X
#
#
# KNOWN ISSUES (FIXED):
#  - Wine x86 4.0.4, 5.0: X
#
   
[ "$PLAYONLINUX" = "" ] && exit 0
source "$PLAYONLINUX/lib/sources"
          
TITLE="Toca Race Driver 3"
PREFIX="TocaRaceDriver3"
EDITOR="Codemasters"
GAME_URL="https://en.wikipedia.org/wiki/TOCA_Race_Driver_3"
AUTHOR="Codemasters"
STEAM_ID=""
GAME_VMS="256"
SHORTCUT_FILENAME="RD3.exe"
SOFTWARE_CATEGORIES="Game;SportsGame;"
# http://wiki.playonlinux.com/index.php/Scripting_-_Chapter_9:_Standardization#Advanced_Standardization
DOCUMENT_FILE="readme.html"
         
# Starting the script
POL_SetupWindow_Init
                      
# Starting debugging API
POL_Debug_Init
     
# Open dialogue box 
POL_SetupWindow_presentation "$TITLE" "$EDITOR" "$GAME_URL" "$AUTHOR" "$PREFIX"
   
# POL_SetupWindow_message "$(eval_gettext 'WARNING: this software does exist in Linux native version.\n\nThis script only allow to run the Windows version on Linux, please prefer the Linux edition for better 3D speed.')" "$TITLE"
   
# POL_SetupWindow_message "$(eval_gettext 'This game requires a fast 3D GPU (ie: Intel HD Graphics 4440 is not enough).')" "$TITLE"
   
POL_RequiredVersion "4.3.0" || POL_Debug_Fatal "$APPLICATION_TITLE $VERSION is required to install $TITLE"
   
# Setting prefix path
POL_Wine_SelectPrefix "$PREFIX"
         
# Determine Architecture
POL_System_SetArch "amd64"
# POL_System_SetArch "x86"
     
# Downloading wine if necessary and creating prefix
POL_Wine_PrefixCreate "4.0.4"
   
POL_System_TmpCreate "$PREFIX"
          
Set_OS "winxp"
  
#######################################
#  Installing mandatory dependencies  #
#######################################
        
# POL_Wine_DirectInput "MouseWarpOverride" "force"

# POL_Call POL_Install_corefonts
# POL_Call POL_Install_mfc42
# POL_Call POL_Install_dsound
# POL_Call POL_Install_quartz
# POL_Call POL_Install_d3dx9_43
# POL_Call POL_Install_d3dcompiler_43
# POL_Call POL_Install_wininet
# POL_Call POL_Install_corefonts
# POL_Call POL_Install_dotnet30sp1
# POL_Call POL_Install_mono5.20
# POL_Call POL_Install_dotnet20
# POL_Call POL_Install_dotnet40
# POL_Call POL_Install_dotnet472
# POL_Call POL_Install_dsound
# POL_Call POL_Install_riched30
# POL_Call POL_Install_corefonts
# POL_Call POL_Install_d3dx11
# POL_Call POL_Install_mono210
              
              
################
#      GPU     #
################
          
# Asking about memory size of graphic card
POL_SetupWindow_VMS $GAME_VMS
           
# Set Graphic Card information keys for wine
POL_Wine_SetVideoDriver
            
# Useful for Nvidia GPUs
POL_Call POL_Install_physx
              
              
#############################################
#  Sound problem fix - pulseaudio related   #
#############################################
# [ "$POL_OS" = "Linux" ] && Set_SoundDriver "alsa"
# [ "$POL_OS" = "Linux" ] && Set_SoundEmulDriver "Y"
## End Fix
           
          
#######################################
#  Main part of this script           #
#######################################
              
# Choose between Steam and other Digital Download versions
# POL_SetupWindow_InstallMethod "STEAM,DVD,LOCAL,DOWNLOAD"
POL_SetupWindow_InstallMethod "DVD,LOCAL"
   
# POL_SetupWindow_message "Warning: do not install DirectX (nor the icons)." "$TITLE"
# POL_SetupWindow_message "Warning: do not install Visual C++ 2013 redistribuable\n nor Direct X." "$TITLE"
           
# Begin game installation
if [ "$INSTALL_METHOD" == "STEAM" ]; then
        POL_Call POL_Install_steam
        # Mandatory pre-install fix for steam
        POL_Call POL_Install_steam_flags "$STEAM_ID"
        # Shortcut done before install for steam version
        POL_Shortcut "steam.exe" "$TITLE" "" "steam://rungameid/$STEAM_ID"
        # Steam install
        POL_SetupWindow_message "$(eval_gettext 'When $TITLE download by Steam is finished,\nDo NOT click on Play.\n\nClose COMPLETELY the Steam interface, \nso that the installation script can continue')" "$TITLE"
        cd "$WINEPREFIX/drive_c/$PROGRAMFILES/Steam"
        POL_Wine start /unix "steam.exe" steam://install/$STEAM_ID
        POL_Wine_WaitExit "$TITLE"
                   
elif [ "$INSTALL_METHOD" == "DVD" ]; then
        POL_SetupWindow_cdrom
                   
        POL_Call POL_Function_NoCDWarning
            
        POL_SetupWindow_check_cdrom "RD3.ico"
        POL_Wine start /unix "$CDROM/setup.exe"
                  
        POL_Wine_WaitExit "$TITLE"
               
        # Restore screen resolution (game's default is 800x600 ?)
        # POL_Shortcut_InsertBeforeWine "$SHORTCUT" "trap 'xrandr -s 0' EXIT"
                  
        POL_Shortcut "$SHORTCUT_FILENAME" "$TITLE" "" "" "$SOFTWARE_CATEGORIES"
        POL_Shortcut_QuietDebug "$TITLE"
        POL_Shortcut_Document "$TITLE" "$DOCUMENT_FILE"

        POL_Shortcut "HardwareSetup.exe" "$TITLE (Hardware setup)" "" "" "$SOFTWARE_CATEGORIES"

elif [ "$INSTALL_METHOD" == "DOWNLOAD" ]; then
        cd "$WINEPREFIX/drive_c"
          
        # POL_SetupWindow_message "$(eval_gettext '\n\nNote: this script will download the demo .')" "$TITLE"
        POL_Download "https://archive.org/download/TheOperativeNoOneLivesForeverDemo/nolftechdemo.exe"
        
        mv nolftechdemo.exe GameInstaller.exe
        # mv Teacher%20Simulator.rar gameinstaller.rar        
        # mv Facewound.zip gameinstaller.zip
        
        # POL_SetupWindow_wait_next_signal "$(eval_gettext 'Extracting the archive...')" "$TITLE"
        # POL_System_unrar x "gameinstaller.rar" "$WINEPREFIX/drive_c/game/" || POL_Debug_Fatal "unrar is required to unarchive $TITLE (unrar package is not installed on the OS)."
        # POL_System_unzip "gameinstaller.zip" -d "$WINEPREFIX/drive_c/game/"
          
        # Extract without sub-folder.
        # unzip "gameinstaller.zip" -j -d "$WINEPREFIX/drive_c/"
          
        # POL_SetupWindow_message "$(eval_gettext 'Note: we recommend you to uncheck all the checkboxes:\n[x] -> [ ]')" "$TITLE"
  
        POL_SetupWindow_message "$(eval_gettext 'Note: just click the buttons <Unzip> then <Close>.')" "$TITLE"
      
        # cd  "$WINEPREFIX/drive_c/game/"
        POL_Wine "GameInstaller.exe" # "/SILENT"
        POL_Wine_WaitBefore "$TITLE"
  
        POL_SetupWindow_message "$(eval_gettext '\n\nNote: do NOT install DirectX.')" "$TITLE"
  
        cd  "$WINEPREFIX/drive_c/nolfdemo/"
        POL_Wine "SETUP.EXE" # "/SILENT"
        POL_Wine_WaitBefore "$TITLE"
  
        cd "$WINEPREFIX/drive_c"
        # rm GameInstaller.exe
        rm GameInstaller.exe
          
        POL_Shortcut "$SHORTCUT_FILENAME" "$TITLE" "" "" "$SOFTWARE_CATEGORIES"
        POL_Shortcut_QuietDebug "$TITLE"
          
        # Restore screen resolution (game's default is 1024x768)
        # POL_Shortcut_InsertBeforeWine "$SHORTCUT" "trap 'xrandr -s 0' EXIT"
               
        POL_Shortcut_Document "$TITLE" "$DOCUMENT_FILE"
        
          
elif [ "$INSTALL_METHOD" == "LOCAL" ]; then
        POL_SetupWindow_menu "$(eval_gettext 'What is the type of the file?.')" "$TITLE" "$(eval_gettext '.EXE')~$(eval_gettext '.ZIP')~$(eval_gettext '.RAR')" "~"
        # POL_SetupWindow_menu "$(eval_gettext 'What is the type of the file?.')" "$TITLE" "$(eval_gettext '.ZIP')~$(eval_gettext '.RAR')" "~"
        # POL_SetupWindow_menu "$(eval_gettext 'What is the type of the file?.')" "$TITLE" "$(eval_gettext '.MSI')~$(eval_gettext '.EXE')" "~"
        
        # APP_ANSWER=".EXE"
  
if [ "$APP_ANSWER" == ".EXE" ]; then
        # Asking then installing local files of the game
        cd "$HOME"
        POL_SetupWindow_browse "$(eval_gettext 'Please select the installation file (.EXE)')" "$TITLE"
        SETUP_EXE="$APP_ANSWER"

        # POL_SetupWindow_message "Note: please answer NO to all the questions that will appear." "$TITLE"

        POL_Wine start /unix "$SETUP_EXE"
        POL_Wine_WaitExit "$TITLE"
              
        # Restore screen resolution (game's default is 640x480 ?)
        # POL_Shortcut_InsertBeforeWine "$SHORTCUT" "trap 'xrandr -s 0' EXIT"
                
        POL_Shortcut "$SHORTCUT_FILENAME" "$TITLE" "" "" "$SOFTWARE_CATEGORIES"
        POL_Shortcut_QuietDebug "$TITLE"
          
        POL_Shortcut_Document "$TITLE" "$DOCUMENT_FILE"

        POL_Shortcut "HardwareSetup.exe" "$TITLE (Hardware setup)" "" "" "$SOFTWARE_CATEGORIES"   
   
elif [ "$APP_ANSWER" == "$(eval_gettext '.MSI')" ]; then
       # Asking then installing local files of the game
        cd "$HOME"
        POL_SetupWindow_browse "$(eval_gettext 'Please select the setup file to run')" "$TITLE"
        SETUP_EXE="$APP_ANSWER"
        POL_Wine msiexec /i  "$SETUP_EXE"
        POL_Wine_WaitExit "$TITLE"
                
        # Restore screen resolution (game's default is 640x480 ?)
        # POL_Shortcut_InsertBeforeWine "$SHORTCUT" "trap 'xrandr -s 0' EXIT"
                
        POL_Shortcut "$SHORTCUT_FILENAME" "$TITLE" "" "" "$SOFTWARE_CATEGORIES"
        POL_Shortcut_QuietDebug "$TITLE"
          
        POL_Shortcut_Document "$TITLE" "$DOCUMENT_FILE"
   
elif [ "$APP_ANSWER" == "$(eval_gettext '.ZIP')" ]; then
        cd "$HOME"
          
        POL_SetupWindow_message "$(eval_gettext '\n\nWARNING: the file name must not have SPACES in its name !.')" "$TITLE"
        POL_SetupWindow_browse "$(eval_gettext 'Please select the .ZIP file')" "$TITLE"
        cd "$POL_System_TmpDir"
        POL_SetupWindow_wait_next_signal "$(eval_gettext 'Extracting the archive...')" "$TITLE"
        POL_System_unzip "$APP_ANSWER" -d "$WINEPREFIX/drive_c/game/"
        
        POL_Shortcut "$SHORTCUT_FILENAME" "$TITLE" "" "" "$SOFTWARE_CATEGORIES"
          
        POL_Shortcut_Document "$TITLE" "$DOCUMENT_FILE"
        
elif [ "$APP_ANSWER" == "$(eval_gettext '.RAR')" ]; then
        cd "$HOME"
        POL_SetupWindow_browse "$(eval_gettext 'Please select the .RAR file')" "$TITLE"
        SETUP_EXE="$APP_ANSWER"
        cd "$POL_System_TmpDir"
        POL_SetupWindow_wait_next_signal "$(eval_gettext 'Extracting the archive...')" "$TITLE"
        POL_System_unrar x "$APP_ANSWER" "$WINEPREFIX/drive_c/game/" || POL_Debug_Fatal "unrar is required to unarchive $TITLE (unrar package is not installed on the OS)."
        POL_Shortcut "$SHORTCUT_FILENAME" "$TITLE" "" "" "$SOFTWARE_CATEGORIES"
         
        POL_Shortcut_Document "$TITLE" "$DOCUMENT_FILE"
   
fi
fi
 
################
# Patch update #
################
     
POL_SetupWindow_menu "$(eval_gettext 'Do you have a official patch-update to install ?')" "$TITLE" "$(eval_gettext 'No')~$(eval_gettext 'Yes')" "~"      
          
if [ "$APP_ANSWER" == "$(eval_gettext 'Yes')" ]; then
        POL_SetupWindow_browse "$(eval_gettext 'Please select the .EXE file to run')" "$TITLE"
        PATCH_EXE="$APP_ANSWER"
        POL_Wine start /unix "$PATCH_EXE"
        POL_Wine_WaitExit "$PATCH_EXE"
fi
           
# POL_SetupWindow_message "$(eval_gettext '\nInstallation is finished ! :)')" "$TITLE"
     
# POL_SetupWindow_message "$(eval_gettext 'WARNING: to avoid to have huge log file, you should type \ninto Debug flags : fixme-all')" "$TITLE"
           
# Fail ?
POL_SetupWindow_message "$LNG_FIN" "$TITLE"
          
POL_System_TmpDelete
POL_SetupWindow_Close
exit 0

Replies

Dadu042 Thursday 1 August 2019 at 19:41
Dadu042

Warning

This update has not been approved yet by the team.
Use it at your own risk

Message

Note: Wine v2.22+ seems to workaround the retail DVD's DRM.

Differences

@@ -1,7 +1,7 @@
 #!/bin/bash
 # Date : (2010-01-23  20-30)
 # Last revision : See changelog
-# Wine version used : 2.22
+# Wine version used : 3.0.3
 # Distribution used to test : Xubuntu 18.04 x64
 # Author : thib25
 # Licence : Retail 
@@ -13,16 +13,21 @@
 #   Wine 1.1.35 -> 2.22 Because on Xubuntu (18.04 x64), once the retail DVD installed Wine crashed before to show anything (same with Wine 1.9.24).
 #   Fix link to Wikipedia picture.
 #   Add (right click) link to readme.html
+#   Add a link to HardwareSetup.exe
+#   Half standardize the NoCD warning.
+# Dadu042 (2019-08-01)
+#   Wine 2.22 -> 3.0.3
 #
 # KNOWN ISSUES:
 # 
-  
+
 [ "$PLAYONLINUX" = "" ] && exit 0
 source "$PLAYONLINUX/lib/sources"
-  
+
+TITLE="Toca Race Driver 3"
 NAME="Toca Race Driver 3"
 PREFIX="TRD3"
-WORKING_WINE_VERSION="2.22"
+WORKING_WINE_VERSION="3.0.3"
 
 if [ "$POL_LANG" == "fr" ]; then
 	INSTALLATION="Installation en cours..."
@@ -31,7 +36,7 @@
  
 	PlayOnLinux ne fournira aucune aide concernant tout travail illégal."
 	ATTENTIONT="Note à propos de la protection anti-copie"
-	POLEND="$NAME a été installé avec succès"
+	POLEND="$NAME a été installé avec succès."
 else
 	INSTALLATION="Installation in progress..."
 	ATTENTION="Please note that this game has a copy protection system
@@ -39,15 +44,23 @@
  
 	PlayOnLinux will not provide any help concerning any illegal stuff."
 	ATTENTIONT="Note about copy protection"
-	POLEND="$NAME has been installed succesfully"
+	POLEND="$NAME has been installed succesfully."
 fi
-  
-  
+
+
 wget https://upload.wikimedia.org/wikipedia/en/f/f0/TOCA_Race_Driver_3_Cover.jpg --output-document="$REPERTOIRE/tmp/leftnotscaled.jpeg"
 convert "$REPERTOIRE/tmp/leftnotscaled.jpeg" -scale 150x356\! "$REPERTOIRE/tmp/left.jpeg"
 POL_SetupWindow_Init "" "$REPERTOIRE/tmp/left.jpeg"
   
 POL_SetupWindow_presentation "$NAME" "Codemasters" "http://www.codemasters.com/tocaracedriver3/" "thib25" "$PREFIX"
+
+if [ "$POL_LANG" == "fr" ]; then
+	POL_SetupWindow_message_image "$ATTENTION" "$ATTENTIONT" "$PLAYONLINUX/themes/tango/warning.png"
+	# POL_Call POL_Function_NoCDWarning
+else
+	# POL_SetupWindow_message_image "$ATTENTION" "$ATTENTIONT" "$PLAYONLINUX/themes/tango/warning.png"
+	POL_Call POL_Function_NoCDWarning
+fi
   
 POL_SetupWindow_cdrom
 POL_SetupWindow_check_cdrom "RD3.ico"
@@ -62,16 +75,15 @@
 wine "$CDROM/setup.exe"
 POL_SetupWindow_detect_exit
   
-# Make Icon
+# Make custom Icon
 convert "$CDROM/RD3.ico" -geometry 32x32 "$REPERTOIRE/icones/32/$NAME"
   
 POL_SetupWindow_make_shortcut "$PREFIX" "$PROGRAMFILES/Codemasters/Race Driver 3" "RD3.exe" "$NAME" "$NAME"
-POL_Shortcut_Document "$TITLE" "readme.html"
-
-POL_SetupWindow_install_wine "2.22"
-Set_WineVersion_Assign "2.22" "$NAME"
+POL_Shortcut_Document "$NAME" "readme.html"
+POL_Shortcut "HardwareSetup.exe" "$NAME (Hardware setup)" ""
 
-POL_SetupWindow_message_image "$ATTENTION" "$ATTENTIONT" "$PLAYONLINUX/themes/tango/warning.png"
+POL_SetupWindow_install_wine "3.0.3"
+Set_WineVersion_Assign "3.0.3" "$NAME"
 
 # Select GPU (if there are 2)
 POL_Call POL_Install_VideoDriver

New source code

#!/bin/bash
# Date : (2010-01-23  20-30)
# Last revision : See changelog
# Wine version used : 3.0.3
# Distribution used to test : Xubuntu 18.04 x64
# Author : thib25
# Licence : Retail 
#
# CHANGELOG:
# thib25 (2010-01-23)
#   First script. Distribution used to test : Ubuntu 9.10.
# Dadu042 (2019-08-01)
#   Wine 1.1.35 -> 2.22 Because on Xubuntu (18.04 x64), once the retail DVD installed Wine crashed before to show anything (same with Wine 1.9.24).
#   Fix link to Wikipedia picture.
#   Add (right click) link to readme.html
#   Add a link to HardwareSetup.exe
#   Half standardize the NoCD warning.
# Dadu042 (2019-08-01)
#   Wine 2.22 -> 3.0.3
#
# KNOWN ISSUES:
# 

[ "$PLAYONLINUX" = "" ] && exit 0
source "$PLAYONLINUX/lib/sources"

TITLE="Toca Race Driver 3"
NAME="Toca Race Driver 3"
PREFIX="TRD3"
WORKING_WINE_VERSION="3.0.3"

if [ "$POL_LANG" == "fr" ]; then
        INSTALLATION="Installation en cours..."
        ATTENTION="Veuillez noter que ce jeu a une protection anti-copie
        et que malheuresement, cela empêche wine de lancer le jeu.
 
        PlayOnLinux ne fournira aucune aide concernant tout travail illégal."
        ATTENTIONT="Note à propos de la protection anti-copie"
        POLEND="$NAME a été installé avec succès."
else
        INSTALLATION="Installation in progress..."
        ATTENTION="Please note that this game has a copy protection system
        and sadly, it prevents Wine from running the game.
 
        PlayOnLinux will not provide any help concerning any illegal stuff."
        ATTENTIONT="Note about copy protection"
        POLEND="$NAME has been installed succesfully."
fi


wget https://upload.wikimedia.org/wikipedia/en/f/f0/TOCA_Race_Driver_3_Cover.jpg --output-document="$REPERTOIRE/tmp/leftnotscaled.jpeg"
convert "$REPERTOIRE/tmp/leftnotscaled.jpeg" -scale 150x356\! "$REPERTOIRE/tmp/left.jpeg"
POL_SetupWindow_Init "" "$REPERTOIRE/tmp/left.jpeg"
  
POL_SetupWindow_presentation "$NAME" "Codemasters" "http://www.codemasters.com/tocaracedriver3/" "thib25" "$PREFIX"

if [ "$POL_LANG" == "fr" ]; then
        POL_SetupWindow_message_image "$ATTENTION" "$ATTENTIONT" "$PLAYONLINUX/themes/tango/warning.png"
        # POL_Call POL_Function_NoCDWarning
else
        # POL_SetupWindow_message_image "$ATTENTION" "$ATTENTIONT" "$PLAYONLINUX/themes/tango/warning.png"
        POL_Call POL_Function_NoCDWarning
fi
  
POL_SetupWindow_cdrom
POL_SetupWindow_check_cdrom "RD3.ico"
  
select_prefix "$REPERTOIRE/wineprefix/$PREFIX"
POL_SetupWindow_prefixcreate
 
PROGRAMFILES=`wine cmd /c echo "%ProgramFiles%" |tr -d '\015' | tr -d '\010'`
PROGRAMFILES=${PROGRAMFILES:3}
  
POL_SetupWindow_wait_next_signal "$INSTALLATION" "$NAME"
wine "$CDROM/setup.exe"
POL_SetupWindow_detect_exit
  
# Make custom Icon
convert "$CDROM/RD3.ico" -geometry 32x32 "$REPERTOIRE/icones/32/$NAME"
  
POL_SetupWindow_make_shortcut "$PREFIX" "$PROGRAMFILES/Codemasters/Race Driver 3" "RD3.exe" "$NAME" "$NAME"
POL_Shortcut_Document "$NAME" "readme.html"
POL_Shortcut "HardwareSetup.exe" "$NAME (Hardware setup)" ""

POL_SetupWindow_install_wine "3.0.3"
Set_WineVersion_Assign "3.0.3" "$NAME"

# Select GPU (if there are 2)
POL_Call POL_Install_VideoDriver

POL_SetupWindow_message "$POLEND" "$NAME"

POL_SetupWindow_Close
exit

Replies

Edited by Dadu042